using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DeliociIXOR
{
    internal class Program
    {
        static int XORDelilaca(int n)
        {
            var delioci = new List<int>();
            int xor = 0;

            for(int i = 1; i <= n/2; i++)
            {
                if(n % i == 0) xor ^= i;
            }
            xor ^= n;
            return xor;
        }

        static void Main(string[] args)
        {
            string[] s = Console.ReadLine().Split(' ');
            int n = int.Parse(s[0]);
            int k = int.Parse(s[1]);

            s = Console.ReadLine().Split(' ');
            int[] d = new int[k];

            var delioci = new List<int>();

            for (int i = 0; i < k; i++)
            {
                d[i] = int.Parse(s[i]);
                int xor = XORDelilaca(d[i]);

                Console.Write(xor + " ");
            }
        }
    }
}